/* checkcast.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2021 Askar Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __CHECKCAST_H
#define __CHECKCAST_H 1

#include "macaddress.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    struct CheckCast
    {
        virtual                         ~CheckCast();
        virtual bool                    operator()( const MacAddress& ) = 0;
    };

    /**********************************************************************************************************/
    struct CheckUnicast : public CheckCast
    {
        virtual bool                    operator()( const MacAddress& ) override;
    };

    /**********************************************************************************************************/
    struct CheckBroadcast : public CheckCast
    {
        virtual bool                    operator()( const MacAddress& ) override;
    };
}

#endif  // __CHECKCAST_H
