/* erspan.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2020, 2021 Askar
    Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __ERSPAN_H
#define __ERSPAN_H 1

#include "timestamp.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class Erspan
    {
    public:
                                        Erspan( const uint8_t* dataErspan, unsigned nBytesErspan );

        const uint8_t*                  data2() const;
        unsigned                        nBytes2() const;

    protected:
        const uint8_t*                  data2_;
        unsigned                        nBytes2_;
    };
}

/*
****************************************************************************************************************
****************************************************************************************************************
*/

namespace trafficmeter
{
    //----------------------------------------------------------------------------------------------------------
    inline const uint8_t*
    Erspan::data2() const
    {
        return data2_;
    }

    //----------------------------------------------------------------------------------------------------------
    inline unsigned
    Erspan::nBytes2() const
    {
        return nBytes2_;
    }
}

#endif  // __ERSPAN_H
