/* fileid.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2021 Askar Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __FILEID_H
#define __FILEID_H 1

#include <cstdint>
#include <ctime>
#include <string>

#include "path.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class FileId
    {
    public:
                                        FileId( int hash, time_t stem, int extension=0 );

        bool                            operator<( FileId ) const;
        int                             hash() const;
        time_t                          stem() const;
        int                             extension() const;
        std::string                     fileName() const;

    protected:
        uintmax_t                       id_;
    };
}

/*
****************************************************************************************************************
****************************************************************************************************************
*/

namespace trafficmeter
{
    //----------------------------------------------------------------------------------------------------------
    inline bool
    FileId::operator<( FileId rhs ) const
    {
        return id_ < rhs.id_;
    }
}

#endif  // __FILEID_H
