/* flow2collection.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2020, 2021 Askar
    Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __FLOW2COLLECTION_H
#define __FLOW2COLLECTION_H 1

#include <map>
#include <libiclass/common>

#include "flow2record.h"
#include "metadata.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class Flow2Collection : public iclass::commont
    {
    public:
                                        Flow2Collection();
                                        ~Flow2Collection();

        void                            push( const Metadata& );
        std::map<BeFlow2,Summary2>*     pull();
        time_t                          oldestGroup() const;
        bool                            isBusy() const;
        long                            nRows() const;

    protected:
        std::map<BeFlow2,Summary2>*     map_c_;
        std::map<BeFlow2,Summary2>*     nextMap_c_;
        time_t                          oldestGroup_c_;
        time_t                          newestGroup_c_;
        volatile mutable bool           hasActivity_c_;
    };
}

#endif  // __FLOW2COLLECTION_H
