/* flow2record.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2020, 2021 Askar
    Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __FLOW2RECORD_H
#define __FLOW2RECORD_H 1

#include <cstdint>
#include <cstring>

#include "macaddress.h"
#include "summary2.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    struct BeFlow2
    {
        MacAddress                      smac;
        MacAddress                      dmac;
        uint16_t                        vlan;
        uint16_t                        etype;

        bool                            operator<( const BeFlow2& ) const;
    };

    /**********************************************************************************************************/
    struct Flow2Record
    {
        BeFlow2                         beFlow2;
        Summary2                        summary2;
    };
}

/*
****************************************************************************************************************
****************************************************************************************************************
*/

namespace trafficmeter
{
    //----------------------------------------------------------------------------------------------------------
    inline bool
    BeFlow2::operator<( const BeFlow2& rhs ) const
    {
        return memcmp( this, &rhs, sizeof(*this) ) < 0;
    }
}

#endif  // __FLOW2RECORD_H
