/* flowrecord.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2020, 2021 Askar
    Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __FLOWRECORD_H
#define __FLOWRECORD_H 1

#include <cstdint>
#include <cstring>

#include "summary.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    struct BeFlow
    {
        uint32_t                        sip;
        uint32_t                        dip;
        uint16_t                        vlan;
        uint16_t                        proto;
        uint16_t                        sport;
        uint16_t                        dport;

        bool                            operator<( const BeFlow& ) const;
    };

    /**********************************************************************************************************/
    struct FlowRecord
    {
        BeFlow                          beFlow;
        Summary                         summary;
    };
}

/*
****************************************************************************************************************
****************************************************************************************************************
*/

namespace trafficmeter
{
    //----------------------------------------------------------------------------------------------------------
    inline bool
    BeFlow::operator<( const BeFlow& rhs ) const
    {
        return memcmp( this, &rhs, 16 ) < 0;
    }
}

#endif  // __FLOWRECORD_H
