/* groupbytime.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2020, 2021 Askar
    Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __GROUPBYTIME_H
#define __GROUPBYTIME_H 1

#include <ctime>

namespace trafficmeter
{
    /**********************************************************************************************************/
    class GroupByTime
    {
    public:
                                        GroupByTime();
        virtual                         ~GroupByTime();

        virtual time_t                  operator()( time_t ) = 0;

    protected:
        time_t                          beginCache_;
        time_t                          endCache_;
    };

    /**********************************************************************************************************/
    struct GroupByHour : public GroupByTime
    {
        virtual time_t                  operator()( time_t ) override;
    };

    /**********************************************************************************************************/
    struct GroupByDay : public GroupByTime
    {
        virtual time_t                  operator()( time_t ) override;
    };

    /**********************************************************************************************************/
    struct GroupByMonth : public GroupByTime
    {
        virtual time_t                  operator()( time_t ) override;
    };

    /**********************************************************************************************************/
    struct IgnoreTime : public GroupByTime
    {
        virtual time_t                  operator()( time_t ) override;
    };
}

#endif  // __GROUPBYTIME_H
