/* iface-bpf.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2020, 2021 Askar
    Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __IFACE_H
#define __IFACE_H 1

#include <cstdint>

#include "source.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class Iface : public Source
    {
    public:
                                        Iface( const std::string& name, bool isPromisc );
        virtual                         ~Iface();

        virtual void                    open() override;
        virtual void                    close() override;
        virtual bool                    checkForRecords() override;
        virtual bool                    copyRecords( uint8_t**, const uint8_t* ) override;
        virtual Packet                  getPacket() override;
        virtual Packet                  getPacketFromCopy( uint8_t** ) const override;
        virtual bool                    isEthernet() const override;

    protected:
        int                             fd_;
        std::string                     device_;
        std::string                     linkType_;
        uint8_t*                        buffer_;
        unsigned                        bufferSize_;
        uint8_t*                        record_;
        uint8_t*                        recordsEnd_;
    };
}

#endif  // __IFACE_H
