/* iniconfig.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2020, 2021 Askar Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __INICONFIG_H
#define __INICONFIG_H 1

#include <map>
#include <string>
#include <vector>

#include "path.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class IniConfig
    {
    public:
                                                IniConfig( const std::string& section );

        const std::string&                      getValue( const std::string& key ) const;
        std::vector<std::string>                getList( const std::string& key ) const;
        bool                                    hasKey( const std::string& key ) const;

        virtual bool                            readFile( const Path& configFile );

    protected:
        std::string                             section_;
        std::map<std::string,std::string>       dictionary_;
    };
}

#endif  // __INICONFIG_H
