/* packetrecord.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2020, 2021 Askar
    Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __PACKETRECORD_H
#define __PACKETRECORD_H 1

#include <cstdint>
#include <arpa/inet.h>

#include "tmdefs.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    struct PacketRecord
    {
        uint64_t                        timestamp;
        uint32_t                        nBytes2;
        uint16_t                        nBytes;
        uint16_t                        vlan;

        const uint8_t*                  data2() const;
        const PacketRecord*             next() const;
    };
}

/*
****************************************************************************************************************
****************************************************************************************************************
*/

namespace trafficmeter
{
    //----------------------------------------------------------------------------------------------------------
    inline const uint8_t*
    PacketRecord::data2() const
    {
        return reinterpret_cast<const uint8_t*>( this + 1 );
    }

    //----------------------------------------------------------------------------------------------------------
    inline const PacketRecord*
    PacketRecord::next() const
    {
        return reinterpret_cast<const PacketRecord*>( data2() + wordAlign(nBytes2) );
    }
}

#endif  // __PACKETRECORD_H
