/* packetwriter.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2015, 2020, 2021 Askar Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __PACKETWRITER_H
#define __PACKETWRITER_H 1

#include <vector>
#include <libiclass/task>

#include "directory.h"
#include "packetcollection.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class PacketWriter : public iclass::taskt
    {
    public:
                                        PacketWriter( Directory* directory, int nChunks );
        virtual                         ~PacketWriter();

        PacketCollection*               getCollection();
        long                            queueSize() const;
        long                            nBuckets() const;
        uintmax_t                       nWritten() const;

    protected:
        virtual void                    routine() override;
        void                            fwrite_();

        const int                       extension_;
        Directory*                      directory_;
        PacketCollection*               collection_;
        uint8_t*                        buffer_;
        std::vector<time_t>             stems_;
        std::vector<uintmax_t>          fileSizes_;
        std::vector<int>                fileDescriptors_;
        std::atomic<uintmax_t>          nWritten_a_;
    };
}

#endif  // __PACKETWRITER_H
