/* param.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2020, 2021 Askar Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __PARAM_H
#define __PARAM_H 1

#include "iniconfig.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    struct Param : public IniConfig
    {
        std::vector<std::string>                sourceNames;
        bool                                    shouldSavePackets;
        bool                                    shouldCheckErspan;
        int                                     verbosity;
        int                                     nExtractors;
        int                                     nFlowWriters;
        int                                     nStatWriters;
        int                                     nExtractorChunks;
        int                                     nCollectionChunks;
        int                                     flowQuota;
        int                                     statQuota;
        int                                     flow2Quota;
        int                                     packetQuota;

                                                Param( const std::string& section );
        virtual bool                            readFile( const Path& configFile ) override;
    };
}

#endif  // __PARAM_H
