/* resourceusage.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2020, 2021 Askar Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __RESOURCEUSAGE_H
#define __RESOURCEUSAGE_H 1

#include <sys/resource.h>

namespace trafficmeter
{
    /**********************************************************************************************************/
    class ResourceUsage
    {
    public:
                                            ResourceUsage();

        void                                startMeasuring();
        void                                stopMeasuring();
        void                                continueMeasuring();
        double                              seconds() const;
        double                              userSeconds() const;
        double                              systemSeconds() const;

    protected:
        struct rusage                       startUsage_;
        struct rusage                       stopUsage_;
        bool                                isStarted_;
        bool                                isStopped_;
        bool                                isContinued_;
    };
}

/*
****************************************************************************************************************
****************************************************************************************************************
*/

namespace trafficmeter
{
    //----------------------------------------------------------------------------------------------------------
    inline double
    ResourceUsage::seconds() const
    {
        return userSeconds() + systemSeconds();
    }
}

#endif  // __RESOURCEUSAGE_H
