/* scheduler.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2021 Askar Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __SCHEDULER_H
#define __SCHEDULER_H 1

#include <string>
#include <libiclass/task>

#include "extractor.h"
#include "source.h"
#include "substratequeue.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class Scheduler : public iclass::taskt
    {
    public:
                                        Scheduler( Source* source );
        virtual                         ~Scheduler();

        void                            attach( Extractor* extractor );

    protected:
        virtual void                    routine() override;

        Source*                         source_;
        SubstrateQueue*                 headQueue_;
    };
}

#endif  // __SCHEDULER_H
