/* slotindex.cc
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2021 Askar Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include "slotindex.h"
#include "tmdefs.h"

using namespace trafficmeter;

/**************************************************************************************************************/
SlotIndex::SlotIndex( const Metadata& meta, int nThreads )
{
    int     sHash = meta.sip & ( (1U << SUFFIX_HASH_LENGTH) - 1 );
    int     dHash = meta.dip & ( (1U << SUFFIX_HASH_LENGTH) - 1 );

    sSlotNo = sHash / nThreads;
    sThreadNo = sHash % nThreads;
    dSlotNo = dHash / nThreads;
    dThreadNo = dHash % nThreads;
}
