/* source.cc
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2020, 2021 Askar
    Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include <cassert>
#include <unistd.h>

#include "source.h"

using namespace trafficmeter;

using std::string;

/**************************************************************************************************************/
Source::Source( const std::string& name ) :
    name_( name ),
    shouldCheckErspan_( false ),
    nReceived_a_( 0 ),
    nDropped_a_( 0 )
{
}

/**************************************************************************************************************/
Source::~Source()
{
}

/**************************************************************************************************************/
void
Source::shouldCheckErspan()
{
    shouldCheckErspan_ = true;;
}

/**************************************************************************************************************/
const std::string&
Source::name() const
{
    return name_;
}

/**************************************************************************************************************/
const std::string&
Source::info() const
{
    return info_;
}
