/* sqlexport.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2021 Askar Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __SQLEXPORT_H
#define __SQLEXPORT_H 1

#define DBPGSQL 1
#undef DBMYSQL

#include <iostream>
#include <string>
#include <vector>
#include <libiclass/dbase>
#include <libiclass/period>

#include "statquery.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class SqlExport : public StatQuery
    {
    public:
                                        SqlExport( const iclass::periodt& period, const std::string& sender );

        void                            fetch();
        long                            execute();
        void                            print( std::ostream& out );
        bool                            isConnected() const;

    protected:
        iclassdb::dbconnt               dbc_;
        std::string                     sender_;
        std::vector<std::string>        statements_;
    };
}

#endif  // __SQLEXPORT_H
