/* statreport.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2020, 2021 Askar
    Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __STATREPORT_H
#define __STATREPORT_H 1

#include <string>

#include "statquery.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class StatReport
    {
    public:
                                        StatReport();

        void                            hideTime();
        void                            showVlans();
        void                            showHosts();
        void                            showFlows();
        bool                            setDivisor( double );
        bool                            setMinimalTraffic( double );
        void                            printHeader() const;
        bool                            printRow( const StatQuery::Key& stat, const SummaryIo& summary ) const;
        void                            printFooter( std::string message, const SummaryIo& summary ) const;

    protected:
        bool                            shouldHideTime_;
        bool                            shouldShowVlans_;
        bool                            shouldShowHosts_;
        bool                            shouldShowFlows_;
        double                          divisor_;
        double                          minimalTraffic_;
    };
}

#endif  // __STATREPORT_H
