/* substrate.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2021 Askar Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __SUBSTRATE_H
#define __SUBSTRATE_H 1

#include <atomic>
#include <cstdint>
#include <vector>

#include "packet.h"
#include "source.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class Substrate
    {
    public:
                                        Substrate();

        bool                            emplaceRecords( Source* source );
        Packet::Body*                   getPacket( Source* source );
        void                            refIncrement();
        void                            refDecrement();
        bool                            isEmpty() const;

    protected:
        uint8_t*                        record_;
        uint8_t*                        recordsEnd_;
        std::atomic<unsigned>           refCount_a_;
    };

    /**********************************************************************************************************/
    struct Substrates : public std::vector<Substrate*>
    {
    };
}

#endif  // __SUBSTRATE_H
