/* substratequeue.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2021 Askar Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __SUBSTRATEQUEUE_H
#define __SUBSTRATEQUEUE_H 1

#include <libiclass/common>

#include "ringallocator.h"
#include "source.h"
#include "substrate.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class SubstrateQueue : public iclass::commont
    {
    public:
                                        SubstrateQueue( int nChunks );
                                        ~SubstrateQueue();

        void                            tieTo( SubstrateQueue* head );
        SubstrateQueue*                 next();
        Substrate*                      newSubstrate();
        void                            push( Substrate* substrate );
        Substrates*                     pull();
        long                            size() const;

    protected:
        RingAllocator                   ring_;
        SubstrateQueue*                 next_;
        std::atomic<long>               size_a_;
        Substrates*                     queue_c_;
    };
}

#endif  // __SUBSTRATEQUEUE_H
