/* summary2.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2020, 2021 Askar
    Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __SUMMARY2_H
#define __SUMMARY2_H 1

#include <cstdint>

namespace trafficmeter
{
    /**********************************************************************************************************/
    class Summary2
    {
    public:
                                        Summary2();

                                        Summary2
                                        (
                                            uintmax_t   nPackets2,
                                            uintmax_t   nBytes2,
                                            uintmax_t   nPackets,
                                            uintmax_t   nBytes
                                        );

        Summary2&                       operator+=( const Summary2& );
        uintmax_t                       nPackets2() const;
        uintmax_t                       nBytes2() const;
        uintmax_t                       nPackets() const;
        uintmax_t                       nBytes() const;

    protected:
        uintmax_t                       nPackets2_;
        uintmax_t                       nBytes2_;
        uintmax_t                       nPackets_;
        uintmax_t                       nBytes_;
    };
}

/*
****************************************************************************************************************
****************************************************************************************************************
*/

namespace trafficmeter
{
    //----------------------------------------------------------------------------------------------------------
    inline
    Summary2::Summary2() :
        nPackets2_( 0 ),
        nBytes2_( 0 ),
        nPackets_( 0 ),
        nBytes_( 0 )
    {
    }

    //----------------------------------------------------------------------------------------------------------
    inline
    Summary2::Summary2( uintmax_t nPackets2, uintmax_t nBytes2, uintmax_t nPackets, uintmax_t nBytes ) :
        nPackets2_( nPackets2 ),
        nBytes2_( nBytes2 ),
        nPackets_( nPackets ),
        nBytes_( nBytes )
    {
    }

    //----------------------------------------------------------------------------------------------------------
    inline Summary2&
    Summary2::operator+=( const Summary2& s )
    {
        nPackets2_ += s.nPackets2_;
        nBytes2_ += s.nBytes2_;
        nPackets_ += s.nPackets_;
        nBytes_ += s.nBytes_;
        return *this;
    }

    //----------------------------------------------------------------------------------------------------------
    inline uintmax_t
    Summary2::nPackets2() const
    {
        return nPackets2_;
    }

    //----------------------------------------------------------------------------------------------------------
    inline uintmax_t
    Summary2::nBytes2() const
    {
        return nBytes2_;
    }

    //----------------------------------------------------------------------------------------------------------
    inline uintmax_t
    Summary2::nPackets() const
    {
        return nPackets_;
    }

    //----------------------------------------------------------------------------------------------------------
    inline uintmax_t
    Summary2::nBytes() const
    {
        return nBytes_;
    }
}

#endif  // __SUMMARY2_H
