/* sweeper.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2020, 2021 Askar
    Almatov

    This file is part of Trafficmeter.

    Trafficmeter is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    Trafficmeter is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License along with Trafficmeter. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef __SWEEPER_H
#define __SWEEPER_H 1

#include <queue>
#include <string>
#include <vector>
#include <libiclass/common>
#include <libiclass/task>

#include "directory.h"

namespace trafficmeter
{
    /**********************************************************************************************************/
    class Sweeper : public iclass::commont, public iclass::taskt
    {
    public:
        virtual                         ~Sweeper();

        void                            attach( Directory* );
        std::vector<Path>               removedFiles();

    protected:
        virtual void                    routine() override;
        void                            removeFile_();

        std::vector<Directory*>         directories_;
        std::queue<Directory::File>     fileQueue_;
        std::vector<Path>               removedFiles_c_;
    };
}

#endif  // __SWEEPER_H
